﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SimpleCalculator
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Decimal firstOp = 0;
        Decimal secondOp = 0;
        Decimal results = 0;
        bool readyForNewOp = true;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void btnAllClick(object sender, RoutedEventArgs e)
        {
            Button calcButton = (Button)sender;
            try
            {
                switch (calcButton.Content.ToString())
                {
                    case "=":
                        //do the operation
                        try
                        {
                            secondOp = System.Convert.ToDecimal(txtCalc.Text);
                            switch (txtMsg.Text.ToString())
                            {
                                case "+":
                                    results = firstOp + secondOp;
                                    break;
                                case "-":
                                    results = firstOp - secondOp;
                                    break;
                                case "*":
                                    results = firstOp * secondOp;
                                    break;
                                case "/":
                                    results = firstOp / secondOp;
                                    break;
                            }
                        }
                        catch (Exception ex)
                        {
                            txtMsg.Text = "E";
                            firstOp = 0;
                            secondOp = 0;
                            txtCalc.Text = "";
                        }

                        txtCalc.Text = results.ToString();  
                        txtMsg.Text = "=";
                        firstOp = 0;
                        secondOp = 0;
                        readyForNewOp = true;
                        break;
                    case "+":  
                        txtMsg.Text = "+";
                        firstOp = System.Convert.ToDecimal(txtCalc.Text);
                        txtCalc.Text = "";
                        readyForNewOp = false;
                        break;
                    case "-": 
                        txtMsg.Text = "-";
                        firstOp = System.Convert.ToDecimal(txtCalc.Text);
                        txtCalc.Text = "";
                        readyForNewOp = false;
                        break;
                    case "*":
                        txtMsg.Text = "*";
                        firstOp = System.Convert.ToDecimal(txtCalc.Text);
                        txtCalc.Text = "";
                        readyForNewOp = false;
                        break;
                    case "/":
                        txtMsg.Text = "/";
                        firstOp = System.Convert.ToDecimal(txtCalc.Text);
                        txtCalc.Text = "";
                        readyForNewOp = false;
                        break;
                    case "C":
                        //clear pending operation
                        txtCalc.Text = "";
                        txtMsg.Text = "";
                        readyForNewOp = true;
                        break;
                    case "CE":
                        //pop 1 item off stack of operations
                        readyForNewOp = true;
                        break;
                    case "<":
                        txtCalc.Focus();
                        
                        System.Windows.Forms.SendKeys.Send("{BACKSPACE}");

                        break;

                    default:
                        if (readyForNewOp)
                        {
                            txtCalc.Text = "";
                            readyForNewOp = false;
                        }
                        txtCalc.Text = txtCalc.Text + calcButton.Content;
                        break;
                }
            }
            catch (Exception ex)
            {
                txtCalc.Text = "";
                txtMsg.Text = "E";
            }

        }

        private void txtCalcFilterText(object sender, TextCompositionEventArgs e)
        {
            TextBox myText = (TextBox)sender;

        }

        private void txtKeyDown(object sender, KeyEventArgs e)
        {
            TextBox myText = (TextBox)sender;
            if (e.Key >= Key.D0 && e.Key <= Key.D9 || e.Key==Key.Back || e.Key==Key.Decimal || e.Key == Key.Subtract || e.Key==Key.Multiply ||
                e.Key == Key.Add)
            {
                try
                {
                    Decimal testNum = System.Convert.ToDecimal(txtCalc.Text);
                }
                catch (Exception ex)
                {
                    txtMsg.Text = "E";
                    e.Handled = true;
                }
            }
            else
            {
                e.Handled = true;
            }
        }

    }
}
